## API Report File for "@microsoft/fast-foundation"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { Behavior } from '@microsoft/fast-element';
import type { CaptureType } from '@microsoft/fast-element';
import { composedContains } from '@microsoft/fast-element/utilities';
import { composedParent } from '@microsoft/fast-element/utilities';
import { Constructable } from '@microsoft/fast-element';
import { CSSDirective } from '@microsoft/fast-element';
import { Direction } from '@microsoft/fast-web-utilities';
import { ElementStyles } from '@microsoft/fast-element';
import { ElementViewTemplate } from '@microsoft/fast-element';
import { FASTElement } from '@microsoft/fast-element';
import { FASTElementDefinition } from '@microsoft/fast-element';
import { Orientation } from '@microsoft/fast-web-utilities';
import { SyntheticViewTemplate } from '@microsoft/fast-element';
import { ViewTemplate } from '@microsoft/fast-element';

// @public
export const AccordionExpandMode: {
    readonly single: "single";
    readonly multi: "multi";
};

// @public
export type AccordionExpandMode = typeof AccordionExpandMode[keyof typeof AccordionExpandMode];

// @public
export type AccordionItemOptions = StartEndOptions & {
    expandedIcon?: string | SyntheticViewTemplate;
    collapsedIcon?: string | SyntheticViewTemplate;
};

// @public
export function accordionItemTemplate(options?: AccordionItemOptions): ElementViewTemplate<FASTAccordionItem>;

// @public
export function accordionTemplate(): ElementViewTemplate<FASTAccordion>;

// @public
export interface AnchoredRegionConfig {
    readonly autoUpdateMode?: AutoUpdateMode;
    readonly fixedPlacement?: boolean;
    readonly horizontalDefaultPosition?: HorizontalPosition;
    readonly horizontalInset?: boolean;
    readonly horizontalPositioningMode?: AxisPositioningMode;
    readonly horizontalScaling?: AxisScalingMode;
    readonly horizontalThreshold?: number;
    readonly horizontalViewportLock?: boolean;
    readonly verticalDefaultPosition?: VerticalPosition;
    readonly verticalInset?: boolean;
    readonly verticalPositioningMode?: AxisPositioningMode;
    readonly verticalScaling?: AxisScalingMode;
    readonly verticalThreshold?: number;
    readonly verticalViewportLock?: boolean;
}

// @public
export type AnchoredRegionPositionLabel = "start" | "insetStart" | "insetEnd" | "end" | "center";

// @public
export function anchoredRegionTemplate(): ElementViewTemplate<FASTAnchoredRegion>;

// @public
export type AnchorOptions = StartEndOptions;

// @public
export function anchorTemplate(options?: AnchorOptions): ElementViewTemplate<FASTAnchor>;

// @public
export function applyMixins(derivedCtor: any, ...baseCtors: any[]): void;

// @public
export class ARIAGlobalStatesAndProperties {
    ariaAtomic: "true" | "false" | string | null;
    ariaBusy: "true" | "false" | string | null;
    ariaControls: string | null;
    ariaCurrent: "page" | "step" | "location" | "date" | "time" | "true" | "false" | string | null;
    ariaDescribedby: string | null;
    ariaDetails: string | null;
    ariaDisabled: "true" | "false" | string | null;
    ariaErrormessage: string | null;
    ariaFlowto: string | null;
    ariaHaspopup: "false" | "true" | "menu" | "listbox" | "tree" | "grid" | "dialog" | string | null;
    ariaHidden: "false" | "true" | string | null;
    ariaInvalid: "false" | "true" | "grammar" | "spelling" | string | null;
    ariaKeyshortcuts: string | null;
    ariaLabel: string | null;
    ariaLabelledby: string | null;
    ariaLive: "assertive" | "off" | "polite" | string | null;
    ariaOwns: string | null;
    ariaRelevant: "additions" | "additions text" | "all" | "removals" | "text" | string | null;
    ariaRoledescription: string | null;
}

// @public
export const AutoUpdateMode: {
    readonly anchor: "anchor";
    readonly auto: "auto";
};

// @public (undocumented)
export type AutoUpdateMode = typeof AutoUpdateMode[keyof typeof AutoUpdateMode];

// @public
export type AvatarOptions = {
    media?: string | SyntheticViewTemplate;
};

// @public
export function avatarTemplate(options?: AvatarOptions): ElementViewTemplate<FASTAvatar>;

// @public
export type AxisPositioningMode = "uncontrolled" | "locktodefault" | "dynamic";

// @public
export type AxisScalingMode = "anchor" | "fill" | "content";

// @public
export function badgeTemplate(): ElementViewTemplate<FASTBadge>;

// @public
export type BreadcrumbItemOptions = StartEndOptions & {
    separator?: string | SyntheticViewTemplate;
};

// @public
export function breadcrumbItemTemplate(options?: BreadcrumbItemOptions): ElementViewTemplate<FASTBreadcrumbItem>;

// @public
export function breadcrumbTemplate(): ElementViewTemplate<FASTBreadcrumb>;

// @public
export type ButtonOptions = StartEndOptions;

// @public
export function buttonTemplate(options?: ButtonOptions): ElementViewTemplate<FASTButton>;

// @public
export function calendarCellTemplate(options: CalendarOptions, todayString: string): ViewTemplate<CalendarDateInfo>;

// @public
export type CalendarDateInfo = {
    day: number;
    month: number;
    year: number;
    disabled?: boolean;
    selected?: boolean;
};

// @public
export type CalendarInfo = MonthInfo & {
    previous: MonthInfo;
    next: MonthInfo;
};

// @public
export type CalendarOptions = StartEndOptions & {
    dataGridCell: TemplateElementDependency;
    dataGridRow: TemplateElementDependency;
    dataGrid: TemplateElementDependency;
    title?: SyntheticViewTemplate | string;
};

// @public (undocumented)
export function calendarRowTemplate(options: CalendarOptions, todayString: string): ViewTemplate;

// @public
export function calendarTemplate(options: CalendarOptions): ElementViewTemplate<FASTCalendar>;

// @public
export function calendarTitleTemplate(): ViewTemplate<FASTCalendar>;

// @public
export function calendarWeekdayTemplate(options: CalendarOptions): ViewTemplate<WeekdayText>;

// @public
export function cardTemplate(): ElementViewTemplate<FASTCard>;

// @public
export type CellItemTemplateOptions = {
    dataGridCell: TemplateElementDependency;
};

// @beta
export function CheckableFormAssociated<T extends ConstructableFormAssociated>(BaseCtor: T): T;

// @beta
export interface CheckableFormAssociated extends FormAssociated {
    // (undocumented)
    checked: boolean;
    // (undocumented)
    checkedAttribute: boolean;
    // (undocumented)
    checkedChanged(oldValue: boolean | undefined, newValue: boolean): void;
    // (undocumented)
    currentChecked: boolean;
    // (undocumented)
    defaultChecked: boolean;
    // (undocumented)
    defaultCheckedChanged(oldValue: boolean | undefined, newValue: boolean): void;
    // (undocumented)
    dirtyChecked: boolean;
}

// @beta
export type CheckableFormAssociatedElement = FormAssociatedElement & CheckableFormAssociated & {
    proxy: HTMLInputElement;
};

// @public
export type CheckboxOptions = {
    checkedIndicator?: string | SyntheticViewTemplate;
    indeterminateIndicator?: string | SyntheticViewTemplate;
};

// @public
export function checkboxTemplate(options?: CheckboxOptions): ElementViewTemplate<FASTCheckbox>;

// @public
export interface ColumnDefinition {
    cellFocusTargetCallback?: (cell: FASTDataGridCell) => HTMLElement;
    cellInternalFocusQueue?: boolean;
    cellTemplate?: ViewTemplate;
    columnDataKey: string;
    gridColumn?: string;
    headerCellFocusTargetCallback?: (cell: FASTDataGridCell) => HTMLElement;
    headerCellInternalFocusQueue?: boolean;
    headerCellTemplate?: ViewTemplate;
    isRowHeader?: boolean;
    title?: string;
}

// @public
export const ComboboxAutocomplete: {
    readonly inline: "inline";
    readonly list: "list";
    readonly both: "both";
    readonly none: "none";
};

// @public
export type ComboboxAutocomplete = typeof ComboboxAutocomplete[keyof typeof ComboboxAutocomplete];

// @public
export type ComboboxOptions = StartEndOptions & {
    indicator?: string | SyntheticViewTemplate;
};

// @public
export function comboboxTemplate(options?: ComboboxOptions): ElementViewTemplate<FASTCombobox>;

export { composedContains }

export { composedParent }

// @beta
export type ConstructableFormAssociated = Constructable<HTMLElement & FASTElement>;

// @public
export interface CSSDesignToken<T extends string | number | boolean | BigInteger | null | Array<any> | symbol | ({
    createCSS?(): string;
} & Record<PropertyKey, any>)> extends DesignToken<T>, CSSDirective {
    readonly cssCustomProperty: string;
}

// @public @deprecated
export type CSSDisplayPropertyValue = "block" | "contents" | "flex" | "grid" | "inherit" | "initial" | "inline" | "inline-block" | "inline-flex" | "inline-grid" | "inline-table" | "list-item" | "none" | "run-in" | "table" | "table-caption" | "table-cell" | "table-column" | "table-column-group" | "table-footer-group" | "table-header-group" | "table-row" | "table-row-group";

// @public
export const darkModeStylesheetBehavior: (styles: ElementStyles) => MatchMediaStyleSheetBehavior;

// @public
export function dataGridCellTemplate(): ElementViewTemplate<FASTDataGridCell>;

// @public
export const DataGridCellTypes: {
    readonly default: "default";
    readonly columnHeader: "columnheader";
    readonly rowHeader: "rowheader";
};

// @public
export type DataGridCellTypes = typeof DataGridCellTypes[keyof typeof DataGridCellTypes];

// @public
export type DataGridOptions = {
    dataGridRow: TemplateElementDependency;
};

// @public
export function dataGridRowTemplate(options: CellItemTemplateOptions): ElementViewTemplate<FASTDataGridRow>;

// @public
export const DataGridRowTypes: {
    readonly default: "default";
    readonly header: "header";
    readonly stickyHeader: "sticky-header";
};

// @public
export type DataGridRowTypes = typeof DataGridRowTypes[keyof typeof DataGridRowTypes];

// @public
export function dataGridTemplate(options: DataGridOptions): ElementViewTemplate<FASTDataGrid>;

// @public
export class DateFormatter {
    constructor(config?: {});
    date: Date;
    dayFormat: DayFormat;
    // (undocumented)
    getDate(date?: {
        day: number;
        month: number;
        year: number;
    } | string | Date, format?: Intl.DateTimeFormatOptions, locale?: string): string;
    getDateObject(date: {
        day: number;
        month: number;
        year: number;
    } | string | Date): Date;
    // (undocumented)
    getDay(day?: number, format?: DayFormat, locale?: string): string;
    // (undocumented)
    getMonth(month?: number, format?: MonthFormat, locale?: string): string;
    // (undocumented)
    getWeekday(weekday?: number, format?: WeekdayFormat, locale?: string): string;
    // (undocumented)
    getWeekdays(format?: WeekdayFormat, locale?: string): string[];
    // (undocumented)
    getYear(year?: number, format?: YearFormat, locale?: string): string;
    locale: string;
    monthFormat: MonthFormat;
    weekdayFormat: WeekdayFormat;
    yearFormat: YearFormat;
}

// @public
export const DayFormat: {
    readonly "2-digit": "2-digit";
    readonly numeric: "numeric";
};

// @public
export type DayFormat = typeof DayFormat[keyof typeof DayFormat];

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIAButton" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIAButton {
    ariaExpanded: "true" | "false" | string | null;
    ariaPressed: "true" | "false" | "mixed" | string | null;
}

// @internal
export interface DelegatesARIAButton extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIACombobox" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIACombobox {
    ariaAutoComplete: "inline" | "list" | "both" | "none" | string | null;
    ariaControls: string | null;
}

// @internal
export interface DelegatesARIACombobox extends DelegatesARIAListbox {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIALink" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIALink {
    ariaExpanded: "true" | "false" | string | null;
}

// @internal
export interface DelegatesARIALink extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIAListbox" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIAListbox {
    ariaActiveDescendant: string | null;
    ariaDisabled: "true" | "false" | string | null;
    ariaExpanded: "true" | "false" | string | null;
    ariaMultiSelectable: "true" | "false" | string | null;
}

// @internal
export interface DelegatesARIAListbox extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIAListboxOption" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIAListboxOption {
    ariaChecked: "true" | "false" | string | null;
    ariaPosInSet: string | null;
    ariaSelected: "true" | "false" | string | null;
    ariaSetSize: string | null;
}

// @internal (undocumented)
export interface DelegatesARIAListboxOption extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIASearch" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIASearch {
}

// @internal
export interface DelegatesARIASearch extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIASelect" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIASelect {
    ariaControls: string | null;
}

// @internal
export interface DelegatesARIASelect extends DelegatesARIAListbox {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIATextbox" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIATextbox {
}

// @internal
export interface DelegatesARIATextbox extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIAToolbar" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIAToolbar {
    ariaLabel: string | null;
    ariaLabelledby: string | null;
}

// @internal
export interface DelegatesARIAToolbar extends ARIAGlobalStatesAndProperties {
}

// @public
export type DerivedDesignTokenValue<T> = T extends Function ? never : (target: HTMLElement) => T;

// @public
export interface DesignToken<T extends string | number | boolean | BigInteger | null | Array<any> | symbol | {}> {
    readonly appliedTo: HTMLElement[];
    deleteValueFor(element: HTMLElement): this;
    getValueFor(element: HTMLElement): StaticDesignTokenValue<T>;
    readonly name: string;
    setValueFor(element: HTMLElement, value: DesignTokenValue<T> | DesignToken<T>): void;
    subscribe(subscriber: DesignTokenSubscriber<this>, target?: HTMLElement): void;
    unsubscribe(subscriber: DesignTokenSubscriber<this>, target?: HTMLElement): void;
    withDefault(value: DesignTokenValue<T> | DesignToken<T>): this;
}

// @public
export const DesignToken: Readonly<{
    create: typeof create;
    notifyConnection(element: HTMLElement): boolean;
    notifyDisconnection(element: HTMLElement): boolean;
    registerRoot(target?: HTMLElement | Document): void;
    unregisterRoot(target?: HTMLElement | Document): void;
}>;

// @public
export interface DesignTokenChangeRecord<T extends DesignToken<any>> {
    target: HTMLElement;
    token: T;
}

// @public
export interface DesignTokenConfiguration {
    cssCustomPropertyName?: string | null;
    name: string;
}

// @public
export interface DesignTokenSubscriber<T extends DesignToken<any>> {
    // (undocumented)
    handleChange(record: DesignTokenChangeRecord<T>): void;
}

// @public
export type DesignTokenValue<T> = StaticDesignTokenValue<T> | DerivedDesignTokenValue<T>;

// @public
export function dialogTemplate(): ElementViewTemplate<FASTDialog>;

// @public @deprecated
export const disabledCursor = "not-allowed";

// @public
export function disclosureTemplate(): ElementViewTemplate<FASTDisclosure>;

// @public @deprecated
export function display(displayValue: CSSDisplayPropertyValue): string;

// @public
export const DividerRole: {
    readonly separator: "separator";
    readonly presentation: "presentation";
};

// @public
export type DividerRole = typeof DividerRole[keyof typeof DividerRole];

// @public
export function dividerTemplate(): ElementViewTemplate<FASTDivider>;

// @public
export type EndOptions = {
    end?: string | SyntheticViewTemplate;
};

// @public
export function endSlotTemplate(options: EndOptions): ViewTemplate<StartEnd>;

// @public
export class FASTAccordion extends FASTElement {
    // @internal (undocumented)
    accordionItems: HTMLElement[];
    // @internal (undocumented)
    accordionItemsChanged(oldValue: HTMLElement[], newValue: HTMLElement[]): void;
    expandmode: AccordionExpandMode;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTAccordionItem" because one of its declarations is marked as @internal
//
// @public
export class FASTAccordionItem extends FASTElement {
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    expandbutton: HTMLElement;
    expanded: boolean;
    headinglevel: 1 | 2 | 3 | 4 | 5 | 6;
    id: string;
}

// @internal
export interface FASTAccordionItem extends StartEnd {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTAnchor" because one of its declarations is marked as @internal
//
// @public
export class FASTAnchor extends FASTElement {
    // @internal (undocumented)
    connectedCallback(): void;
    control: HTMLAnchorElement;
    // @internal
    defaultSlottedContent: HTMLElement[];
    download: string;
    href: string;
    hreflang: string;
    ping: string;
    referrerpolicy: string;
    rel: string;
    target: "_self" | "_blank" | "_parent" | "_top";
    type: string;
}

// @internal
export interface FASTAnchor extends StartEnd, DelegatesARIALink {
}

// @public
export class FASTAnchoredRegion extends FASTElement {
    // @internal (undocumented)
    adoptedCallback(): void;
    anchor: string;
    // (undocumented)
    protected anchorChanged(): void;
    anchorElement: HTMLElement | null;
    // (undocumented)
    protected anchorElementChanged(): void;
    autoUpdateMode: AutoUpdateMode;
    // (undocumented)
    protected autoUpdateModeChanged(prevMode: AutoUpdateMode, newMode: AutoUpdateMode): void;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    fixedPlacement: boolean;
    // (undocumented)
    protected fixedPlacementChanged(): void;
    horizontalDefaultPosition: HorizontalPosition;
    // (undocumented)
    protected horizontalDefaultPositionChanged(): void;
    horizontalInset: boolean;
    // (undocumented)
    protected horizontalInsetChanged(): void;
    horizontalPosition: AnchoredRegionPositionLabel | undefined;
    horizontalPositioningMode: AxisPositioningMode;
    // (undocumented)
    protected horizontalPositioningModeChanged(): void;
    horizontalScaling: AxisScalingMode;
    // (undocumented)
    protected horizontalScalingChanged(): void;
    horizontalThreshold: number;
    // (undocumented)
    protected horizontalThresholdChanged(): void;
    horizontalViewportLock: boolean;
    // (undocumented)
    protected horizontalViewportLockChanged(): void;
    // @internal
    initialLayoutComplete: boolean;
    update: () => void;
    verticalDefaultPosition: VerticalPosition;
    // (undocumented)
    protected verticalDefaultPositionChanged(): void;
    verticalInset: boolean;
    // (undocumented)
    protected verticalInsetChanged(): void;
    verticalPosition: AnchoredRegionPositionLabel | undefined;
    verticalPositioningMode: AxisPositioningMode;
    // (undocumented)
    protected verticalPositioningModeChanged(): void;
    verticalScaling: AxisScalingMode;
    // (undocumented)
    protected verticalScalingChanged(): void;
    verticalThreshold: number;
    // (undocumented)
    protected verticalThresholdChanged(): void;
    verticalViewportLock: boolean;
    // (undocumented)
    protected verticalViewportLockChanged(): void;
    viewport: string;
    // (undocumented)
    protected viewportChanged(): void;
    viewportElement: HTMLElement | null;
    // (undocumented)
    protected viewportElementChanged(): void;
}

// @public
export class FASTAvatar extends FASTElement {
    link: string;
}

// @public
export class FASTBadge extends FASTElement {
}

// @public
export class FASTBaseProgress extends FASTElement {
    // @internal (undocumented)
    connectedCallback(): void;
    max: number;
    // (undocumented)
    protected maxChanged(): void;
    min: number;
    // (undocumented)
    protected minChanged(): void;
    paused: boolean;
    // @internal
    percentComplete: number;
    value: number | null;
    // (undocumented)
    protected valueChanged(): void;
}

// @public
export class FASTBreadcrumb extends FASTElement {
    // @internal (undocumented)
    slottedBreadcrumbItems: HTMLElement[];
    // (undocumented)
    protected slottedBreadcrumbItemsChanged(): void;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTBreadcrumbItem" because one of its declarations is marked as @internal
//
// @public
export class FASTBreadcrumbItem extends FASTAnchor {
    // @internal (undocumented)
    separator: boolean;
}

// @internal
export interface FASTBreadcrumbItem extends StartEnd, DelegatesARIALink {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedButton" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTButton" because one of its declarations is marked as @internal
//
// @public
export class FASTButton extends FormAssociatedButton {
    autofocus: boolean;
    // @internal (undocumented)
    connectedCallback(): void;
    // (undocumented)
    control: HTMLButtonElement;
    defaultSlottedContent: HTMLElement[];
    // @internal (undocumented)
    disconnectedCallback(): void;
    formaction: string;
    // (undocumented)
    protected formactionChanged(): void;
    formenctype: string;
    // (undocumented)
    protected formenctypeChanged(): void;
    formId: string;
    formmethod: string;
    // (undocumented)
    protected formmethodChanged(): void;
    formnovalidate: boolean;
    // (undocumented)
    protected formnovalidateChanged(): void;
    formtarget: "_self" | "_blank" | "_parent" | "_top";
    // (undocumented)
    protected formtargetChanged(): void;
    type: "submit" | "reset" | "button";
    // (undocumented)
    protected typeChanged(previous: "submit" | "reset" | "button" | void, next: "submit" | "reset" | "button"): void;
}

// @internal
export interface FASTButton extends StartEnd, DelegatesARIAButton {
}

// @public
export class FASTCalendar extends FASTElement {
    dateFormatter: DateFormatter;
    dateInString(date: Date | string, datesString: string): boolean;
    dayFormat: DayFormat;
    // (undocumented)
    protected dayFormatChanged(): void;
    disabledDates: string;
    getDayClassNames(date: CalendarDateInfo, todayString?: string): string;
    getDays(info?: CalendarInfo, minWeeks?: number): CalendarDateInfo[][];
    getMonthInfo(month?: number, year?: number): CalendarInfo;
    getWeekdayText(): WeekdayText[];
    handleDateSelect(event: Event, day: CalendarDateInfo): void;
    handleKeydown(event: KeyboardEvent, date: CalendarDateInfo): boolean;
    locale: string;
    // (undocumented)
    protected localeChanged(): void;
    minWeeks: number;
    month: number;
    monthFormat: MonthFormat;
    // (undocumented)
    protected monthFormatChanged(): void;
    readonly: boolean;
    selectedDates: string;
    weekdayFormat: WeekdayFormat;
    // (undocumented)
    protected weekdayFormatChanged(): void;
    year: number;
    yearFormat: YearFormat;
    // (undocumented)
    protected yearFormatChanged(): void;
}

// @public
export class FASTCard extends FASTElement {
}

// Warning: (ae-forgotten-export) The symbol "FormAssociatedCheckbox" needs to be exported by the entry point index.d.ts
//
// @public
export class FASTCheckbox extends FormAssociatedCheckbox {
    constructor();
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    indeterminate: boolean;
    // @internal
    initialValue: string;
    // @internal (undocumented)
    keypressHandler: (e: KeyboardEvent) => void;
    readOnly: boolean;
    // (undocumented)
    protected readOnlyChanged(): void;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedCombobox" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTCombobox" because one of its declarations is marked as @internal
//
// @public
export class FASTCombobox extends FormAssociatedCombobox {
    autocomplete: ComboboxAutocomplete | undefined;
    // @internal
    clickHandler(e: MouseEvent): boolean | void;
    // (undocumented)
    connectedCallback(): void;
    // @internal
    control: HTMLInputElement;
    // @internal
    disabledChanged(prev: boolean, next: boolean): void;
    filteredOptions: FASTListboxOption[];
    filterOptions(): void;
    // @internal
    protected focusAndScrollOptionIntoView(): void;
    // @internal
    focusoutHandler(e: FocusEvent): boolean | void;
    // @internal
    formResetCallback(): void;
    // @internal
    inputHandler(e: InputEvent): boolean | void;
    // @internal
    keydownHandler(e: Event & KeyboardEvent): boolean | void;
    // @internal
    keyupHandler(e: KeyboardEvent): boolean | void;
    // @internal
    listbox: HTMLDivElement;
    // @internal
    listboxId: string;
    // @internal
    maxHeight: number;
    open: boolean;
    // @internal
    protected openChanged(): void;
    get options(): FASTListboxOption[];
    set options(value: FASTListboxOption[]);
    placeholder: string;
    // @internal
    protected placeholderChanged(): void;
    position?: SelectPosition;
    positionAttribute?: SelectPosition;
    // (undocumented)
    protected positionChanged(prev: SelectPosition | undefined, next: SelectPosition | undefined): void;
    // @internal
    selectedIndexChanged(prev: number | undefined, next: number): void;
    // @internal
    selectedOptionsChanged(prev: FASTListboxOption[] | undefined, next: FASTListboxOption[]): void;
    // @internal
    selectPreviousOption(): void;
    // @internal
    setDefaultSelectedOption(): void;
    setPositioning(): void;
    // @internal
    slottedOptionsChanged(prev: Element[] | undefined, next: Element[]): void;
    get value(): string;
    set value(next: string);
}

// @internal
export interface FASTCombobox extends StartEnd, DelegatesARIACombobox {
}

// @public
export class FASTDataGrid extends FASTElement {
    constructor();
    cellItemTemplate?: ViewTemplate;
    columnDefinitions: ColumnDefinition[] | null;
    // (undocumented)
    protected columnDefinitionsChanged(): void;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    defaultRowItemTemplate: ViewTemplate;
    // @internal (undocumented)
    disconnectedCallback(): void;
    focusColumnIndex: number;
    focusRowIndex: number;
    static generateColumns: (row: object) => ColumnDefinition[];
    generateHeader: GenerateHeaderOptions;
    gridTemplateColumns: string;
    // (undocumented)
    protected gridTemplateColumnsChanged(): void;
    // @internal (undocumented)
    handleFocus(e: FocusEvent): void;
    // @internal (undocumented)
    handleFocusOut(e: FocusEvent): void;
    // @internal (undocumented)
    handleKeydown(e: KeyboardEvent): void;
    // @internal (undocumented)
    handleRowFocus(e: Event): void;
    headerCellItemTemplate?: ViewTemplate;
    noTabbing: boolean;
    // (undocumented)
    protected noTabbingChanged(): void;
    // @internal
    rowElements: HTMLElement[];
    rowElementTag: string;
    rowItemTemplate: ViewTemplate;
    rowsData: object[];
    // (undocumented)
    protected rowsDataChanged(): void;
}

// @public
export class FASTDataGridCell extends FASTElement {
    cellType: DataGridCellTypes;
    columnDefinition: ColumnDefinition | null;
    // (undocumented)
    protected columnDefinitionChanged(oldValue: ColumnDefinition | null, newValue: ColumnDefinition | null): void;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    gridColumn: string;
    // (undocumented)
    protected gridColumnChanged(): void;
    // (undocumented)
    handleFocusin(e: FocusEvent): void;
    // (undocumented)
    handleFocusout(e: FocusEvent): void;
    // (undocumented)
    handleKeydown(e: KeyboardEvent): void;
    rowData: object | null;
}

// @public
export class FASTDataGridRow extends FASTElement {
    // @internal
    activeCellItemTemplate?: ViewTemplate;
    // @internal
    cellElements: HTMLElement[];
    cellItemTemplate?: ViewTemplate;
    columnDefinitions: ColumnDefinition[] | null;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    defaultCellItemTemplate?: ViewTemplate;
    // @internal
    defaultHeaderCellItemTemplate?: ViewTemplate;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    focusColumnIndex: number;
    gridTemplateColumns: string;
    // (undocumented)
    protected gridTemplateColumnsChanged(): void;
    // (undocumented)
    handleCellFocus(e: Event): void;
    // (undocumented)
    handleFocusout(e: FocusEvent): void;
    // (undocumented)
    handleKeydown(e: KeyboardEvent): void;
    headerCellItemTemplate?: ViewTemplate;
    // @internal
    isActiveRow: boolean;
    rowData: object | null;
    // (undocumented)
    protected rowDataChanged(): void;
    rowIndex: number;
    rowType: DataGridRowTypes;
    // @internal (undocumented)
    slottedCellElements: HTMLElement[];
}

// @public
export class FASTDialog extends FASTElement {
    ariaDescribedby: string;
    ariaLabel: string;
    ariaLabelledby: string;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    dialog: HTMLDivElement;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    dismiss(): void;
    // @internal (undocumented)
    handleChange(source: any, propertyName: string): void;
    hidden: boolean;
    hide(): void;
    modal: boolean;
    noFocusTrap: boolean;
    show(): void;
}

// @public
export class FASTDisclosure extends FASTElement {
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    details: HTMLDetailsElement;
    // @internal (undocumented)
    disconnectedCallback(): void;
    expanded: boolean;
    hide(): void;
    protected onToggle(): void;
    protected setup(): void;
    show(): void;
    summary: string;
    toggle(): void;
}

// @public
export class FASTDivider extends FASTElement {
    orientation: Orientation;
    role: DividerRole;
}

// @public
export class FASTFlipper extends FASTElement {
    direction: FlipperDirection;
    disabled: boolean;
    hiddenFromAT: boolean;
    keyupHandler(e: Event & KeyboardEvent): void;
}

// @public
export class FASTHorizontalScroll extends FASTElement {
    // (undocumented)
    connectedCallback(): void;
    content: HTMLDivElement;
    // (undocumented)
    disconnectedCallback(): void;
    duration: string;
    easing: ScrollEasing;
    flippersHiddenFromAT: boolean;
    keyupHandler(e: Event & KeyboardEvent): void;
    nextFlipperContainer: HTMLDivElement;
    previousFlipperContainer: HTMLDivElement;
    resized(): void;
    scrollContainer: HTMLDivElement;
    scrolled(): void;
    // @internal
    scrollingChanged(prev: unknown, next: boolean): void;
    scrollInView(item: HTMLElement | number, padding?: number, rightPadding?: number): void;
    scrollItems: HTMLElement[];
    scrollItemsChanged(previous: HTMLElement[], next: HTMLElement[]): void;
    scrollToNext(): void;
    scrollToPosition(newPosition: number, position?: number): void;
    scrollToPrevious(): void;
    speed: number;
    view: HorizontalScrollView;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTListbox" because one of its declarations is marked as @internal
//
// @public
export abstract class FASTListbox extends FASTElement {
    // @internal
    clickHandler(e: MouseEvent): boolean | void;
    disabled: boolean;
    // @internal
    get firstSelectedOption(): FASTListboxOption;
    // @internal
    protected focusAndScrollOptionIntoView(optionToFocus?: FASTListboxOption | null): void;
    // @internal
    focusinHandler(e: FocusEvent): void;
    // @internal
    protected getSelectableIndex(prev: number | undefined, next: number): number;
    // @internal
    protected getTypeaheadMatches(): FASTListboxOption[];
    // @internal
    handleChange(source: any, propertyName: string): void;
    // @internal
    handleTypeAhead(key: string): void;
    // @internal
    protected get hasSelectableOptions(): boolean;
    // @internal
    keydownHandler(e: KeyboardEvent): boolean | void;
    get length(): number;
    // @internal
    mousedownHandler(e: MouseEvent): boolean | void;
    // @internal
    multipleChanged(prev: boolean | undefined, next: boolean): void;
    get options(): FASTListboxOption[];
    set options(value: FASTListboxOption[]);
    // @internal
    protected _options: FASTListboxOption[];
    selectedIndex: number;
    // @internal
    selectedIndexChanged(prev: number | undefined, next: number): void;
    selectedOptions: FASTListboxOption[];
    // @internal
    protected selectedOptionsChanged(prev: FASTListboxOption[] | undefined, next: FASTListboxOption[]): void;
    selectFirstOption(): void;
    // @internal
    selectLastOption(): void;
    // @internal
    selectNextOption(): void;
    // @internal
    selectPreviousOption(): void;
    // @internal
    protected setDefaultSelectedOption(): void;
    protected setSelectedOptions(): void;
    // @internal
    protected shouldSkipFocus: boolean;
    static slottedOptionFilter: (n: HTMLElement) => boolean;
    // @internal
    slottedOptions: Element[];
    // @internal
    slottedOptionsChanged(prev: Element[] | undefined, next: Element[]): void;
    // @internal
    protected static readonly TYPE_AHEAD_TIMEOUT_MS = 1000;
    // @internal
    protected typeaheadBuffer: string;
    // @internal
    typeaheadBufferChanged(prev: string, next: string): void;
    // @internal @deprecated
    protected get typeAheadExpired(): boolean;
    protected set typeAheadExpired(value: boolean);
    // @internal
    protected typeaheadExpired: boolean;
    // @internal
    protected typeaheadTimeout: number;
}

// @internal (undocumented)
export interface FASTListbox extends DelegatesARIAListbox {
}

// @public
export class FASTListboxElement extends FASTListbox {
    // @internal
    protected activeIndex: number;
    // @internal
    protected activeIndexChanged(prev: number | undefined, next: number): void;
    // @internal
    get activeOption(): FASTListboxOption | null;
    // @internal
    protected checkActiveIndex(): void;
    // @internal
    protected get checkedOptions(): FASTListboxOption[];
    // @internal
    protected checkFirstOption(preserveChecked?: boolean): void;
    // @internal
    protected checkLastOption(preserveChecked?: boolean): void;
    // @internal
    protected checkNextOption(preserveChecked?: boolean): void;
    // @internal
    protected checkPreviousOption(preserveChecked?: boolean): void;
    // @internal @override
    clickHandler(e: MouseEvent): boolean | void;
    // @internal @override (undocumented)
    connectedCallback(): void;
    // @internal @override (undocumented)
    disconnectedCallback(): void;
    // @internal
    get firstSelectedOptionIndex(): number;
    // @internal @override (undocumented)
    protected focusAndScrollOptionIntoView(): void;
    // @internal @override
    focusinHandler(e: FocusEvent): boolean | void;
    // @internal
    focusoutHandler(e: FocusEvent): void;
    // @internal @override
    keydownHandler(e: KeyboardEvent): boolean | void;
    // @internal @override
    mousedownHandler(e: MouseEvent): boolean | void;
    multiple: boolean;
    // @internal
    multipleChanged(prev: boolean | undefined, next: boolean): void;
    // @internal
    protected rangeStartIndex: number;
    // @override
    protected setSelectedOptions(): void;
    size: number;
    // @internal
    protected sizeChanged(prev: number | unknown, next: number): void;
    // @internal
    toggleSelectedForAllCheckedOptions(): void;
    // @internal @override (undocumented)
    typeaheadBufferChanged(prev: string, next: string): void;
    // @internal
    protected uncheckAllOptions(preserveChecked?: boolean): void;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTListboxOption" because one of its declarations is marked as @internal
//
// @public
export class FASTListboxOption extends FASTElement {
    constructor(text?: string, value?: string, defaultSelected?: boolean, selected?: boolean);
    checked?: boolean;
    protected checkedChanged(prev: boolean | unknown, next?: boolean): void;
    content: Node[];
    // @internal
    protected contentChanged(prev: undefined | Node[], next: Node[]): void;
    defaultSelected: boolean;
    // (undocumented)
    protected defaultSelectedChanged(): void;
    dirtyValue: boolean;
    disabled: boolean;
    // (undocumented)
    protected disabledChanged(prev: boolean, next: boolean): void;
    // (undocumented)
    get form(): HTMLFormElement | null;
    protected initialValue: string;
    // (undocumented)
    initialValueChanged(previous: string, next: string): void;
    // (undocumented)
    get label(): string;
    // @internal (undocumented)
    proxy: HTMLOptionElement;
    selected: boolean;
    selectedAttribute: boolean;
    // (undocumented)
    protected selectedAttributeChanged(): void;
    // (undocumented)
    protected selectedChanged(): void;
    // (undocumented)
    get text(): string;
    set value(next: string);
    // (undocumented)
    get value(): string;
}

// @internal (undocumented)
export interface FASTListboxOption extends StartEnd, DelegatesARIAListboxOption {
}

// @public
export class FASTMenu extends FASTElement {
    collapseExpandedItem(): void;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    focus(): void;
    // @internal
    handleFocusOut: (e: FocusEvent) => void;
    // @internal (undocumented)
    handleMenuKeyDown(e: KeyboardEvent): void | boolean;
    // @internal (undocumented)
    readonly isNestedMenu: () => boolean;
    // @internal (undocumented)
    items: HTMLSlotElement;
    // (undocumented)
    protected itemsChanged(oldValue: HTMLElement[], newValue: HTMLElement[]): void;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTMenuItem" because one of its declarations is marked as @internal
//
// @public
export class FASTMenuItem extends FASTElement {
    checked: boolean;
    // (undocumented)
    protected checkedChanged(oldValue: boolean, newValue: boolean): void;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    currentDirection: Direction;
    disabled: boolean;
    // @internal (undocumented)
    disconnectedCallback(): void;
    expanded: boolean;
    // (undocumented)
    protected expandedChanged(oldValue: boolean): void;
    // @internal (undocumented)
    handleMenuItemClick: (e: MouseEvent) => boolean;
    // @internal (undocumented)
    handleMenuItemKeyDown: (e: KeyboardEvent) => boolean;
    // @internal (undocumented)
    handleMouseOut: (e: MouseEvent) => boolean;
    // @internal (undocumented)
    handleMouseOver: (e: MouseEvent) => boolean;
    // @internal (undocumented)
    hasSubmenu: boolean;
    role: MenuItemRole;
    // @internal (undocumented)
    startColumnCount: MenuItemColumnCount;
    // @internal (undocumented)
    submenu: Element | undefined;
    // @internal (undocumented)
    submenuLoaded: () => void;
    // @internal
    submenuRegion: FASTAnchoredRegion;
}

// @internal
export interface FASTMenuItem extends StartEnd {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedNumberField" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTNumberField" because one of its declarations is marked as @internal
//
// @public
export class FASTNumberField extends FormAssociatedNumberField {
    autofocus: boolean;
    // @internal
    connectedCallback(): void;
    // @internal
    control: HTMLInputElement;
    // @internal
    defaultSlottedNodes: Node[];
    // @internal
    handleBlur(): void;
    // @internal
    handleChange(): void;
    // @internal
    handleKeyDown(e: KeyboardEvent): boolean;
    // @internal
    handleTextInput(): void;
    hideStep: boolean;
    list: string;
    max: number;
    // @internal
    maxChanged(previous: number, next: number): void;
    maxlength: number;
    min: number;
    // @internal
    minChanged(previous: number, next: number): void;
    minlength: number;
    placeholder: string;
    readOnly: boolean;
    protected select(): void;
    size: number;
    step: number;
    stepDown(): void;
    stepUp(): void;
    get valueAsNumber(): number;
    set valueAsNumber(next: number);
    // @internal
    valueChanged(previous: string, next: string): void;
}

// @internal
export interface FASTNumberField extends StartEnd, DelegatesARIATextbox {
}

// Warning: (ae-forgotten-export) The symbol "FormAssociatedPicker" needs to be exported by the entry point index.d.ts
//
// @beta
export class FASTPicker extends FormAssociatedPicker {
    // @internal
    activeListItemTemplate?: ViewTemplate;
    // @internal
    activeMenuOptionTemplate?: ViewTemplate;
    // @internal (undocumented)
    connectedCallback(): void;
    defaultListItemTemplate?: ViewTemplate;
    // (undocumented)
    protected defaultListItemTemplateChanged(): void;
    defaultMenuOptionTemplate?: ViewTemplate;
    // (undocumented)
    protected defaultMenuOptionTemplateChanged(): void;
    // (undocumented)
    disconnectedCallback(): void;
    // @internal
    filteredOptionsList: string[];
    // (undocumented)
    protected filteredOptionsListChanged(): void;
    filterQuery: boolean;
    filterSelected: boolean;
    // @internal
    flyoutOpen: boolean;
    // (undocumented)
    protected flyoutOpenChanged(): void;
    // @public
    focus(): void;
    handleFocusIn(e: FocusEvent): boolean;
    handleFocusOut(e: FocusEvent): boolean;
    handleItemInvoke(e: Event): boolean;
    handleKeyDown(e: KeyboardEvent): boolean;
    handleOptionInvoke(e: Event): boolean;
    handleRegionLoaded(e: Event): void;
    handleSelectionChange(): void;
    // @internal
    inputElement: HTMLInputElement;
    itemsPlaceholderElement: Node;
    label: string;
    labelledBy: string;
    // @internal
    listElement: FASTPickerList;
    listItemContentsTemplate: ViewTemplate;
    listItemTemplate: ViewTemplate;
    // (undocumented)
    protected listItemTemplateChanged(): void;
    loadingText: string;
    maxSelected: number | undefined;
    // @internal
    menuConfig: AnchoredRegionConfig;
    // @internal
    menuElement: FASTPickerMenu;
    // @internal
    menuFocusIndex: number;
    // @internal
    menuFocusOptionId: string | undefined;
    // @internal
    menuId: string;
    menuOptionContentsTemplate: ViewTemplate;
    menuOptionTemplate: ViewTemplate;
    // (undocumented)
    protected menuOptionTemplateChanged(): void;
    menuPlacement: menuConfigs;
    // (undocumented)
    protected menuPlacementChanged(): void;
    // @internal
    menuTag: string;
    noSuggestionsText: string;
    options: string;
    // (undocumented)
    protected optionsChanged(): void;
    optionsList: string[];
    placeholder: string;
    query: string;
    // (undocumented)
    protected queryChanged(): void;
    // @internal
    region: FASTAnchoredRegion;
    // @internal (undocumented)
    selectedItems: string[];
    // @internal
    selectedListTag: string;
    selection: string;
    // (undocumented)
    protected selectionChanged(): void;
    showLoading: boolean;
    // (undocumented)
    protected showLoadingChanged(): void;
    // @internal
    showNoOptions: boolean;
    suggestionsAvailableText: string;
}

// @beta
export class FASTPickerList extends FASTElement {
}

// @beta
export class FASTPickerListItem extends FASTElement {
    // @internal (undocumented)
    connectedCallback(): void;
    contentsTemplate: ViewTemplate;
    // (undocumented)
    protected contentsTemplateChanged(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // (undocumented)
    handleClick(e: MouseEvent): boolean;
    // (undocumented)
    handleKeyDown(e: KeyboardEvent): boolean;
    value: string;
}

// @beta
export class FASTPickerMenu extends FASTElement {
    // @internal
    footerElements: HTMLElement[];
    // (undocumented)
    footerElementsChanged(): void;
    // @internal
    headerElements: HTMLElement[];
    // (undocumented)
    headerElementsChanged(): void;
    // @internal
    menuElements: HTMLElement[];
    // (undocumented)
    menuElementsChanged(): void;
    // @internal
    optionElements: HTMLElement[];
    suggestionsAvailableText: string;
}

// @beta
export class FASTPickerMenuOption extends FASTElement {
    // @internal (undocumented)
    connectedCallback(): void;
    contentsTemplate: ViewTemplate;
    // (undocumented)
    protected contentsTemplateChanged(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // (undocumented)
    handleClick(e: MouseEvent): boolean;
    value: string;
}

// @public
export class FASTProgress extends FASTBaseProgress {
}

// @public
export class FASTProgressRing extends FASTBaseProgress {
}

// Warning: (ae-forgotten-export) The symbol "FormAssociatedRadio" needs to be exported by the entry point index.d.ts
//
// @public
export class FASTRadio extends FormAssociatedRadio implements RadioControl {
    constructor();
    // @beta
    clickHandler(e: MouseEvent): boolean | void;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    defaultCheckedChanged(): void;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal
    initialValue: string;
    // @beta
    keypressHandler(e: KeyboardEvent): boolean | void;
    name: string;
    readOnly: boolean;
    // (undocumented)
    protected readOnlyChanged(): void;
}

// @public
export class FASTRadioGroup extends FASTElement {
    // (undocumented)
    childItems: HTMLElement[];
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    connectedCallback(): void;
    disabled: boolean;
    // (undocumented)
    protected disabledChanged(): void;
    // (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    focusOutHandler: (e: FocusEvent) => boolean | void;
    // @internal
    keydownHandler: (e: KeyboardEvent) => boolean | void;
    name: string;
    // (undocumented)
    protected nameChanged(): void;
    orientation: Orientation | "horizontal" | "vertical";
    readOnly: boolean;
    // (undocumented)
    protected readOnlyChanged(): void;
    // @internal (undocumented)
    slottedRadioButtons: HTMLElement[];
    // (undocumented)
    protected slottedRadioButtonsChanged(oldValue: unknown, newValue: HTMLElement[]): void;
    value: string;
    // (undocumented)
    protected valueChanged(): void;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedSearch" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTSearch" because one of its declarations is marked as @internal
//
// @public
export class FASTSearch extends FormAssociatedSearch {
    autofocus: boolean;
    // (undocumented)
    protected autofocusChanged(): void;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    control: HTMLInputElement;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal
    handleChange(): void;
    handleClearInput(): void;
    // @internal
    handleTextInput(): void;
    list: string;
    // (undocumented)
    protected listChanged(): void;
    maxlength: number;
    // (undocumented)
    protected maxlengthChanged(): void;
    minlength: number;
    // (undocumented)
    protected minlengthChanged(): void;
    pattern: string;
    // (undocumented)
    protected patternChanged(): void;
    placeholder: string;
    // (undocumented)
    protected placeholderChanged(): void;
    readOnly: boolean;
    // (undocumented)
    protected readOnlyChanged(): void;
    // @internal
    root: HTMLDivElement;
    size: number;
    // (undocumented)
    protected sizeChanged(): void;
    spellcheck: boolean;
    // (undocumented)
    protected spellcheckChanged(): void;
}

// @internal
export interface FASTSearch extends StartEnd, DelegatesARIASearch {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedSelect" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTSelect" because one of its declarations is marked as @internal
//
// @public
export class FASTSelect extends FormAssociatedSelect {
    // @internal
    clickHandler(e: MouseEvent): boolean | void;
    // @internal
    get collapsible(): boolean;
    // (undocumented)
    connectedCallback(): void;
    // @internal
    control: HTMLElement;
    // @internal
    disabledChanged(prev: boolean, next: boolean): void;
    // (undocumented)
    disconnectedCallback(): void;
    get displayValue(): string;
    // @internal
    focusoutHandler(e: FocusEvent): boolean | void;
    // @internal
    formResetCallback(): void;
    // @internal @override
    handleChange(source: any, propertyName: string): void;
    // @internal
    keydownHandler(e: KeyboardEvent): boolean | void;
    // @internal
    listbox: HTMLDivElement;
    // @internal
    listboxId: string;
    // @internal
    maxHeight: number;
    // @internal @override
    mousedownHandler(e: MouseEvent): boolean | void;
    multipleChanged(prev: boolean | undefined, next: boolean): void;
    open: boolean;
    // @internal
    protected openChanged(prev: boolean | undefined, next: boolean): void;
    position?: SelectPosition;
    positionAttribute?: SelectPosition;
    // (undocumented)
    protected positionChanged(prev: SelectPosition | undefined, next: SelectPosition | undefined): void;
    // @internal
    selectedIndexChanged(prev: number | undefined, next: number): void;
    // @internal @override
    protected selectedOptionsChanged(prev: FASTListboxOption[] | undefined, next: FASTListboxOption[]): void;
    // @internal @override
    protected setDefaultSelectedOption(): void;
    setPositioning(): void;
    // @internal @override
    protected sizeChanged(prev: number | undefined, next: number): void;
    // @internal
    slottedOptionsChanged(prev: Element[] | undefined, next: Element[]): void;
    get value(): string;
    set value(next: string);
}

// @internal (undocumented)
export interface FASTSelect extends StartEnd, DelegatesARIASelect {
}

// @public
export class FASTSkeleton extends FASTElement {
    fill: string;
    pattern: string;
    shape: SkeletonShape;
    shimmer: boolean;
}

// Warning: (ae-forgotten-export) The symbol "FormAssociatedSlider" needs to be exported by the entry point index.d.ts
//
// @public
export class FASTSlider extends FormAssociatedSlider implements SliderConfiguration {
    // @internal (undocumented)
    connectedCallback(): void;
    decrement(): void;
    // @internal (undocumented)
    direction: Direction;
    // @internal (undocumented)
    disconnectedCallback(): void;
    increment(): void;
    // @internal (undocumented)
    initialValue: string;
    // @internal (undocumented)
    isDragging: boolean;
    // (undocumented)
    protected keypressHandler: (e: KeyboardEvent) => void;
    max: number;
    min: number;
    mode: SliderMode;
    orientation: Orientation;
    // @internal (undocumented)
    position: string;
    readOnly: boolean;
    // (undocumented)
    protected readOnlyChanged(): void;
    step: number;
    // @internal (undocumented)
    stepMultiplier: number;
    // @internal (undocumented)
    thumb: HTMLDivElement;
    // @internal (undocumented)
    track: HTMLDivElement;
    // @internal (undocumented)
    trackHeight: number;
    // @internal (undocumented)
    trackLeft: number;
    // @internal (undocumented)
    trackMinHeight: number;
    // @internal (undocumented)
    trackMinWidth: number;
    // @internal (undocumented)
    trackWidth: number;
    get valueAsNumber(): number;
    set valueAsNumber(next: number);
    // @internal (undocumented)
    valueChanged(previous: string, next: string): void;
    valueTextFormatter: (value: string) => string | null;
}

// @public
export class FASTSliderLabel extends FASTElement {
    // @internal (undocumented)
    connectedCallback(): void;
    disabled: boolean;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    handleChange(source: any, propertyName: string): void;
    hideMark: boolean;
    position: string;
    // (undocumented)
    protected positionChanged(): void;
    // @internal (undocumented)
    positionStyle: string;
    // @internal (undocumented)
    root: HTMLDivElement;
    // @internal (undocumented)
    sliderDirection: Direction;
    // @internal (undocumented)
    sliderMaxPosition: number;
    // @internal (undocumented)
    sliderMinPosition: number;
    // @internal (undocumented)
    sliderOrientation: Orientation;
    // @internal (undocumented)
    protected sliderOrientationChanged(): void;
}

// Warning: (ae-forgotten-export) The symbol "FormAssociatedSwitch" needs to be exported by the entry point index.d.ts
//
// @public
export class FASTSwitch extends FormAssociatedSwitch {
    constructor();
    // @internal (undocumented)
    checkedChanged(prev: boolean | undefined, next: boolean): void;
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal
    initialValue: string;
    // @internal (undocumented)
    keypressHandler: (e: KeyboardEvent) => void;
    readOnly: boolean;
    // (undocumented)
    protected readOnlyChanged(): void;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTTab" because one of its declarations is marked as @internal
//
// @public
export class FASTTab extends FASTElement {
    disabled: boolean;
}

// @internal
export interface FASTTab extends StartEnd {
}

// @public
export class FASTTabPanel extends FASTElement {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTTabs" because one of its declarations is marked as @internal
//
// @public
export class FASTTabs extends FASTElement {
    activeid: string;
    // @internal (undocumented)
    activeidChanged(oldValue: string, newValue: string): void;
    // @internal (undocumented)
    activeIndicatorRef: HTMLElement;
    activetab: HTMLElement;
    adjust(adjustment: number): void;
    // @internal (undocumented)
    connectedCallback(): void;
    hideActiveIndicator: boolean;
    orientation: TabsOrientation;
    // @internal (undocumented)
    orientationChanged(): void;
    // @internal (undocumented)
    showActiveIndicator: boolean;
    // @internal (undocumented)
    tabpanels: HTMLElement[];
    // @internal (undocumented)
    tabpanelsChanged(): void;
    // @internal (undocumented)
    tabs: HTMLElement[];
    // @internal (undocumented)
    tabsChanged(): void;
}

// @internal
export interface FASTTabs extends StartEnd {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedTextArea" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTTextArea" because one of its declarations is marked as @internal
//
// @public
export class FASTTextArea extends FormAssociatedTextArea {
    autofocus: boolean;
    // (undocumented)
    protected autofocusChanged(): void;
    cols: number;
    // @internal
    control: HTMLTextAreaElement;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    formId: string;
    // @internal
    handleChange(): void;
    // @internal (undocumented)
    handleTextInput: () => void;
    list: string;
    // (undocumented)
    protected listChanged(): void;
    maxlength: number;
    // (undocumented)
    protected maxlengthChanged(): void;
    minlength: number;
    // (undocumented)
    protected minlengthChanged(): void;
    name: string;
    placeholder: string;
    readOnly: boolean;
    // (undocumented)
    protected readOnlyChanged(): void;
    resize: TextAreaResize;
    rows: number;
    protected select(): void;
    spellcheck: boolean;
    // (undocumented)
    protected spellcheckChanged(): void;
}

// @internal
export interface FASTTextArea extends DelegatesARIATextbox {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedTextField" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTTextField" because one of its declarations is marked as @internal
//
// @public
export class FASTTextField extends FormAssociatedTextField {
    autofocus: boolean;
    // (undocumented)
    protected autofocusChanged(): void;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    control: HTMLInputElement;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal
    handleChange(): void;
    // @internal
    handleTextInput(): void;
    list: string;
    // (undocumented)
    protected listChanged(): void;
    maxlength: number;
    // (undocumented)
    protected maxlengthChanged(): void;
    minlength: number;
    // (undocumented)
    protected minlengthChanged(): void;
    pattern: string;
    // (undocumented)
    protected patternChanged(): void;
    placeholder: string;
    // (undocumented)
    protected placeholderChanged(): void;
    readOnly: boolean;
    // (undocumented)
    protected readOnlyChanged(): void;
    protected select(): void;
    size: number;
    // (undocumented)
    protected sizeChanged(): void;
    spellcheck: boolean;
    // (undocumented)
    protected spellcheckChanged(): void;
    type: TextFieldType;
}

// @internal
export interface FASTTextField extends StartEnd, DelegatesARIATextbox {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTToolbar" because one of its declarations is marked as @internal
//
// @public
export class FASTToolbar extends FASTElement {
    // @internal
    get activeIndex(): number;
    set activeIndex(value: number);
    // @internal
    protected get allSlottedItems(): (HTMLElement | Node)[];
    // (undocumented)
    childItems: Element[];
    // (undocumented)
    protected childItemsChanged(prev: undefined | Element[], next: Element[]): void;
    // @internal
    clickHandler(e: MouseEvent): boolean | void;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    direction: Direction;
    // @internal
    focusinHandler(e: FocusEvent): boolean | void;
    // @internal
    keydownHandler(e: KeyboardEvent): boolean | void;
    orientation: Orientation;
    // @internal
    protected reduceFocusableElements(): void;
    // @internal
    slottedItems: HTMLElement[];
    // (undocumented)
    protected slottedItemsChanged(): void;
    // @internal
    slottedLabel: HTMLElement[];
}

// @internal (undocumented)
export interface FASTToolbar extends StartEnd, DelegatesARIAToolbar {
}

// @public
export class FASTTooltip extends FASTElement {
    anchor: string;
    // (undocumented)
    protected anchorChanged(): void;
    anchorElement: HTMLElement | null;
    // (undocumented)
    protected anchorElementChanged(oldValue: HTMLElement | null): void;
    autoUpdateMode: AutoUpdateMode;
    // (undocumented)
    connectedCallback(): void;
    // @internal
    currentDirection: Direction;
    delay: number;
    // (undocumented)
    disconnectedCallback(): void;
    // @internal
    handlePositionChange: (ev: Event) => void;
    // @internal (undocumented)
    horizontalDefaultPosition: string | undefined;
    // @internal (undocumented)
    horizontalInset: string;
    // @internal (undocumented)
    horizontalPositioningMode: AxisPositioningMode;
    // @internal (undocumented)
    horizontalScaling: AxisScalingMode;
    horizontalViewportLock: boolean;
    position: TooltipPosition;
    // @internal
    region: FASTAnchoredRegion;
    // @internal (undocumented)
    tooltipVisible: boolean;
    // @internal (undocumented)
    verticalDefaultPosition: string | undefined;
    // @internal (undocumented)
    verticalInset: string;
    // @internal (undocumented)
    verticalPositioningMode: AxisPositioningMode;
    // @internal (undocumented)
    verticalScaling: AxisScalingMode;
    verticalViewportLock: boolean;
    // @internal
    viewportElement: HTMLElement | null;
    // (undocumented)
    protected viewportElementChanged(): void;
    visible: boolean;
    // (undocumented)
    protected visibleChanged(): void;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FASTTreeItem" because one of its declarations is marked as @internal
//
// @public
export class FASTTreeItem extends FASTElement {
    // @internal
    childItemLength(): number;
    // @internal (undocumented)
    childItems: HTMLElement[];
    disabled: boolean;
    // @internal
    expandCollapseButton: HTMLDivElement;
    expanded: boolean;
    // (undocumented)
    protected expandedChanged(): void;
    // @internal
    focusable: boolean;
    static focusItem(el: HTMLElement): void;
    // @internal
    handleBlur: (e: FocusEvent) => void;
    // @internal
    handleExpandCollapseButtonClick: (e: MouseEvent) => void;
    // @internal
    handleFocus: (e: FocusEvent) => void;
    readonly isNestedItem: () => boolean;
    // @internal
    items: HTMLElement[];
    // (undocumented)
    protected itemsChanged(oldValue: unknown, newValue: HTMLElement[]): void;
    // @internal
    nested: boolean;
    // @internal (undocumented)
    renderCollapsedChildren: boolean;
    selected: boolean;
    // (undocumented)
    protected selectedChanged(): void;
}

// @internal
export interface FASTTreeItem extends StartEnd {
}

// @public
export class FASTTreeView extends FASTElement {
    // (undocumented)
    connectedCallback(): void;
    // @internal
    currentFocused: HTMLElement | FASTTreeItem | null;
    currentSelected: HTMLElement | FASTTreeItem | null;
    // @internal
    handleBlur: (e: FocusEvent) => void;
    // @internal
    handleClick(e: Event): boolean | void;
    // @internal
    handleFocus: (e: FocusEvent) => void;
    // @internal
    handleKeyDown: (e: KeyboardEvent) => boolean | void;
    // @internal
    handleSelectedChange: (e: Event) => boolean | void;
    renderCollapsedNodes: boolean;
    // @internal
    slottedTreeItems: HTMLElement[];
    // (undocumented)
    protected slottedTreeItemsChanged(): void;
    // @internal
    treeView: HTMLElement;
}

// @public
export const FlipperDirection: {
    readonly next: "next";
    readonly previous: "previous";
};

// @public
export type FlipperDirection = typeof FlipperDirection[keyof typeof FlipperDirection];

// @public
export type FlipperOptions = {
    next?: string | SyntheticViewTemplate;
    previous?: string | SyntheticViewTemplate;
};

// @public
export function flipperTemplate(options?: FlipperOptions): ElementViewTemplate<FASTFlipper>;

// @public
export const FlyoutPosBottom: AnchoredRegionConfig;

// @public
export const FlyoutPosBottomFill: AnchoredRegionConfig;

// @public
export const FlyoutPosTallest: AnchoredRegionConfig;

// @public
export const FlyoutPosTallestFill: AnchoredRegionConfig;

// @public
export const FlyoutPosTop: AnchoredRegionConfig;

// @public
export const FlyoutPosTopFill: AnchoredRegionConfig;

// @public @deprecated
export const focusVisible = "focus-visible";

// @public
export const forcedColorsStylesheetBehavior: (styles: ElementStyles) => MatchMediaStyleSheetBehavior;

// @beta
export function FormAssociated<T extends ConstructableFormAssociated>(BaseCtor: T): T;

// Warning: (ae-forgotten-export) The symbol "ElementInternals" needs to be exported by the entry point index.d.ts
//
// @beta
export interface FormAssociated extends Omit<ElementInternals_2, "labels"> {
    // (undocumented)
    attachProxy(): void;
    // (undocumented)
    currentValue: string;
    // (undocumented)
    detachProxy(): void;
    // (undocumented)
    dirtyValue: boolean;
    // (undocumented)
    disabled: boolean;
    // (undocumented)
    disabledChanged?(previous: boolean, next: boolean): void;
    // (undocumented)
    readonly elementInternals: ElementInternals_2 | null;
    // (undocumented)
    readonly formAssociated: boolean;
    // (undocumented)
    formDisabledCallback?(disabled: boolean): void;
    // (undocumented)
    formResetCallback(): void;
    // (undocumented)
    initialValue: string;
    // (undocumented)
    initialValueChanged?(previous: string, next: string): void;
    // (undocumented)
    readonly labels: ReadonlyArray<Node[]>;
    // (undocumented)
    name: string;
    // (undocumented)
    nameChanged?(previous: string, next: string): void;
    // (undocumented)
    required: boolean;
    // (undocumented)
    requiredChanged(prev: boolean, next: boolean): void;
    // (undocumented)
    stopPropagation(e: Event): void;
    // (undocumented)
    validate(): void;
    // (undocumented)
    value: string;
    // (undocumented)
    valueChanged(previous: string, next: string): void;
}

// @beta
export type FormAssociatedElement = FormAssociated & FASTElement & HTMLElement & FormAssociatedProxy;

// @beta
export interface FormAssociatedProxy {
    // (undocumented)
    disabledChanged?(previous: boolean, next: boolean): void;
    // (undocumented)
    formDisabledCallback?(disabled: boolean): void;
    // (undocumented)
    formResetCallback?(): void;
    // (undocumented)
    initialValueChanged?(previous: string, next: string): void;
    // (undocumented)
    nameChanged?(previous: string, next: string): void;
    // (undocumented)
    proxy: ProxyElement;
    // (undocumented)
    valueChanged?(previous: string, next: string): void;
}

// @public
export const GenerateHeaderOptions: {
    readonly none: "none";
    readonly default: "default";
    readonly sticky: "sticky";
};

// @public
export type GenerateHeaderOptions = typeof GenerateHeaderOptions[keyof typeof GenerateHeaderOptions];

// @public
export const getDirection: (rootNode: HTMLElement) => Direction;

// @public @deprecated
export const hidden = ":host([hidden]){display:none}";

// @public
export type HorizontalPosition = "start" | "end" | "left" | "right" | "center" | "unset";

// @public
export type HorizontalScrollOptions = StartEndOptions & {
    nextFlipper?: SyntheticViewTemplate | string;
    previousFlipper?: SyntheticViewTemplate | string;
};

// @public (undocumented)
export function horizontalScrollTemplate(options?: HorizontalScrollOptions): ElementViewTemplate<FASTHorizontalScroll>;

// @public
export type HorizontalScrollView = "default" | "mobile";

// Warning: (ae-internal-missing-underscore) The name "interactiveCalendarGridTemplate" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export function interactiveCalendarGridTemplate(options: CalendarOptions, todayString: string): ViewTemplate<FASTCalendar>;

// @public
export function isListboxOption(el: Element): el is FASTListboxOption;

// @public
export function isTreeItemElement(el: Element): el is HTMLElement;

// @public
export const lightModeStylesheetBehavior: (styles: ElementStyles) => MatchMediaStyleSheetBehavior;

// @public
export type ListboxOptionOptions = StartEndOptions;

// @public
export function listboxOptionTemplate(options?: ListboxOptionOptions): ElementViewTemplate<FASTListboxOption>;

// @public
export function listboxTemplate(): ElementViewTemplate<FASTListboxElement>;

// @public
export abstract class MatchMediaBehavior implements Behavior {
    constructor(query: MediaQueryList);
    bind(source: typeof FASTElement & HTMLElement): void;
    protected abstract constructListener(source: typeof FASTElement): MediaQueryListListener;
    readonly query: MediaQueryList;
    unbind(source: typeof FASTElement & HTMLElement): void;
}

// @public
export class MatchMediaStyleSheetBehavior extends MatchMediaBehavior {
    constructor(query: MediaQueryList, styles: ElementStyles);
    protected constructListener(source: typeof FASTElement): MediaQueryListListener;
    readonly query: MediaQueryList;
    readonly styles: ElementStyles;
    // @internal
    unbind(source: typeof FASTElement & HTMLElement): void;
    static with(query: MediaQueryList): (styles: ElementStyles) => MatchMediaStyleSheetBehavior;
}

// @public
export type MediaQueryListListener = (this: MediaQueryList, ev?: MediaQueryListEvent) => void;

// @beta
export type menuConfigs = "bottom" | "bottom-fill" | "tallest" | "tallest-fill" | "top" | "top-fill";

// @public
export type MenuItemColumnCount = 0 | 1 | 2;

// @public
export type MenuItemOptions = StartEndOptions & {
    checkboxIndicator?: string | SyntheticViewTemplate;
    expandCollapseGlyph?: string | SyntheticViewTemplate;
    radioIndicator?: string | SyntheticViewTemplate;
    anchoredRegion: TemplateElementDependency;
};

// @public
export const MenuItemRole: {
    readonly menuitem: "menuitem";
    readonly menuitemcheckbox: "menuitemcheckbox";
    readonly menuitemradio: "menuitemradio";
};

// @public
export type MenuItemRole = typeof MenuItemRole[keyof typeof MenuItemRole];

// @public
export function menuItemTemplate(options: MenuItemOptions): ElementViewTemplate<FASTMenuItem>;

// @public
export function menuTemplate(): ElementViewTemplate<FASTMenu>;

// @public
export const MonthFormat: {
    readonly "2-digit": "2-digit";
    readonly numeric: "numeric";
    readonly short: "short";
    readonly long: "long";
    readonly narrow: "narrow";
};

// @public
export type MonthFormat = typeof MonthFormat[keyof typeof MonthFormat];

// @public
export type MonthInfo = {
    month: number;
    year: number;
    length: number;
    start: number;
};

// Warning: (ae-internal-missing-underscore) The name "noninteractiveCalendarTemplate" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export function noninteractiveCalendarTemplate(options: CalendarOptions, todayString: string): ViewTemplate<FASTCalendar>;

// @public
export type NumberFieldOptions = StartEndOptions & {
    stepDownGlyph?: string | SyntheticViewTemplate;
    stepUpGlyph?: string | SyntheticViewTemplate;
};

// @public
export function numberFieldTemplate(options?: NumberFieldOptions): ElementViewTemplate<FASTNumberField>;

// Warning: (ae-incompatible-release-tags) The symbol "pickerListItemTemplate" is marked as @public, but its signature references "FASTPickerListItem" which is marked as @beta
//
// @public (undocumented)
export function pickerListItemTemplate(): ElementViewTemplate<FASTPickerListItem>;

// Warning: (ae-incompatible-release-tags) The symbol "pickerListTemplate" is marked as @public, but its signature references "FASTPickerList" which is marked as @beta
//
// @public (undocumented)
export function pickerListTemplate(): ElementViewTemplate<FASTPickerList>;

// Warning: (ae-incompatible-release-tags) The symbol "pickerMenuOptionTemplate" is marked as @public, but its signature references "FASTPickerMenuOption" which is marked as @beta
//
// @public (undocumented)
export function pickerMenuOptionTemplate(): ElementViewTemplate<FASTPickerMenuOption>;

// Warning: (ae-incompatible-release-tags) The symbol "pickerMenuTemplate" is marked as @public, but its signature references "FASTPickerMenu" which is marked as @beta
//
// @public
export function pickerMenuTemplate(): ElementViewTemplate<FASTPickerMenu>;

// @public
export type PickerOptions = {
    anchoredRegion: TemplateElementDependency;
    pickerMenu: TemplateElementDependency;
    pickerMenuOption: TemplateElementDependency;
    pickerList: TemplateElementDependency;
    pickerListItem: TemplateElementDependency;
    progressRing: TemplateElementDependency;
};

// Warning: (ae-incompatible-release-tags) The symbol "pickerTemplate" is marked as @public, but its signature references "FASTPicker" which is marked as @beta
//
// @public
export function pickerTemplate(options: PickerOptions): ElementViewTemplate<FASTPicker>;

// @public
export type ProgressOptions = {
    indeterminateIndicator1?: string | SyntheticViewTemplate;
    indeterminateIndicator2?: string | SyntheticViewTemplate;
};

// @public
export type ProgressRingOptions = {
    indeterminateIndicator?: string | SyntheticViewTemplate;
};

// @public
export function progressRingTemplate(options?: ProgressRingOptions): ElementViewTemplate<FASTProgressRing>;

// @public
export function progressTemplate(options?: ProgressOptions): ElementViewTemplate<FASTProgress>;

// @public
export class PropertyStyleSheetBehavior implements Behavior {
    constructor(propertyName: string, value: any, styles: ElementStyles);
    bind(elementInstance: FASTElement): void;
    // @internal
    handleChange(source: FASTElement, key: string): void;
    unbind(source: typeof FASTElement & HTMLElement): void;
}

// @beta
export type ProxyElement = HTMLSelectElement | HTMLTextAreaElement | HTMLInputElement;

// @public
export type RadioControl = Pick<HTMLInputElement, "checked" | "disabled" | "readOnly" | "focus" | "setAttribute" | "getAttribute">;

// @public
export function radioGroupTemplate(): ElementViewTemplate<FASTRadioGroup>;

// @public
export type RadioOptions = {
    checkedIndicator?: string | SyntheticViewTemplate;
};

// @public
export function radioTemplate(options?: RadioOptions): ElementViewTemplate<FASTRadio>;

// @beta
export function reflectAttributes<T = any>(...attributes: string[]): CaptureType<T>;

// Warning: (ae-internal-missing-underscore) The name "roleForMenuItem" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const roleForMenuItem: {
    [value in keyof typeof MenuItemRole]: typeof MenuItemRole[value];
};

// @public
export type ScrollEasing = "linear" | "ease-in" | "ease-out" | "ease-in-out" | string;

// @public
export type SearchOptions = StartEndOptions;

// @public
export function searchTemplate(options?: SearchOptions): ElementViewTemplate<FASTSearch>;

// @public
export type SelectOptions = StartEndOptions & {
    indicator?: string | SyntheticViewTemplate;
};

// @public
export const SelectPosition: {
    readonly above: "above";
    readonly below: "below";
};

// @public
export type SelectPosition = typeof SelectPosition[keyof typeof SelectPosition];

// @public
export function selectTemplate(options?: SelectOptions): ElementViewTemplate<FASTSelect>;

// @public
export const SkeletonShape: {
    readonly rect: "rect";
    readonly circle: "circle";
};

// @public (undocumented)
export type SkeletonShape = typeof SkeletonShape[keyof typeof SkeletonShape];

// @public
export function skeletonTemplate(): ElementViewTemplate<FASTSkeleton>;

// @public
export interface SliderConfiguration {
    // (undocumented)
    direction?: Direction;
    // (undocumented)
    disabled?: boolean;
    // (undocumented)
    max: number;
    // (undocumented)
    min: number;
    // (undocumented)
    orientation?: Orientation;
}

// @public
export function sliderLabelTemplate(): ElementViewTemplate<FASTSliderLabel>;

// @public
export const SliderMode: {
    readonly singleValue: "single-value";
};

// @public
export type SliderMode = typeof SliderMode[keyof typeof SliderMode];

// @public
export type SliderOptions = {
    thumb?: string | SyntheticViewTemplate;
};

// @public
export function sliderTemplate(options?: SliderOptions): ElementViewTemplate<FASTSlider>;

// @public
export class StartEnd {
    // (undocumented)
    end: HTMLSlotElement;
    // (undocumented)
    start: HTMLSlotElement;
}

// @public
export type StartEndOptions = StartOptions & EndOptions;

// @public
export type StartOptions = {
    start?: string | SyntheticViewTemplate;
};

// @public
export function startSlotTemplate(options: StartOptions): ViewTemplate<StartEnd>;

// @public
export type StaticDesignTokenValue<T> = T extends Function ? never : T;

// @alpha (undocumented)
export const supportsElementInternals: boolean;

// @public
export type SwitchOptions = {
    switch?: string | SyntheticViewTemplate;
};

// @public
export function switchTemplate(options?: SwitchOptions): ElementViewTemplate<FASTSwitch>;

// @public
export type TabOptionOptions = StartEndOptions;

// @public
export function tabPanelTemplate(): ElementViewTemplate<FASTTabPanel>;

// @public
export type TabsOptions = StartEndOptions;

// @public
export const TabsOrientation: {
    readonly vertical: "vertical";
    readonly horizontal: "horizontal";
};

// @public
export type TabsOrientation = typeof TabsOrientation[keyof typeof TabsOrientation];

// @public
export function tabsTemplate(options?: TabsOptions): ElementViewTemplate<FASTTabs>;

// @public
export function tabTemplate(options?: StartEndOptions): ElementViewTemplate<FASTTab>;

// @beta
export function tagFor(dependency: TemplateElementDependency): string;

// @beta
export type TemplateElementDependency = string | FASTElementDefinition | Constructable<FASTElement>;

// @public
export const TextAreaResize: {
    readonly none: "none";
    readonly both: "both";
    readonly horizontal: "horizontal";
    readonly vertical: "vertical";
};

// @public
export type TextAreaResize = typeof TextAreaResize[keyof typeof TextAreaResize];

// @public
export function textAreaTemplate(): ElementViewTemplate<FASTTextArea>;

// @public
export type TextFieldOptions = StartEndOptions;

// @public
export function textFieldTemplate(options?: TextFieldOptions): ElementViewTemplate<FASTTextField>;

// @public
export const TextFieldType: {
    readonly email: "email";
    readonly password: "password";
    readonly tel: "tel";
    readonly text: "text";
    readonly url: "url";
};

// @public
export type TextFieldType = typeof TextFieldType[keyof typeof TextFieldType];

// @public
export type ToolbarOptions = StartEndOptions;

// @public
export function toolbarTemplate(options?: ToolbarOptions): ElementViewTemplate<FASTToolbar>;

// @public
export type TooltipOptions = {
    anchoredRegion: TemplateElementDependency;
};

// @public
export const TooltipPosition: {
    readonly top: "top";
    readonly right: "right";
    readonly bottom: "bottom";
    readonly left: "left";
    readonly start: "start";
    readonly end: "end";
    readonly topLeft: "top-left";
    readonly topRight: "top-right";
    readonly bottomLeft: "bottom-left";
    readonly bottomRight: "bottom-right";
    readonly topStart: "top-start";
    readonly topEnd: "top-end";
    readonly bottomStart: "bottom-start";
    readonly bottomEnd: "bottom-end";
};

// @public
export type TooltipPosition = typeof TooltipPosition[keyof typeof TooltipPosition];

// @public
export function tooltipTemplate(options: TooltipOptions): ElementViewTemplate<FASTTooltip>;

// @public
export type TreeItemOptions = StartEndOptions & {
    expandCollapseGlyph?: string | SyntheticViewTemplate;
};

// @public
export function treeItemTemplate(options?: TreeItemOptions): ElementViewTemplate<FASTTreeItem>;

// @public
export function treeViewTemplate(): ElementViewTemplate<FASTTreeView>;

// @public
export type VerticalPosition = "top" | "bottom" | "center" | "unset";

// @public
export const WeekdayFormat: {
    readonly long: "long";
    readonly narrow: "narrow";
    readonly short: "short";
};

// @public
export type WeekdayFormat = typeof WeekdayFormat[keyof typeof WeekdayFormat];

// @public
export type WeekdayText = {
    text: string;
    abbr?: string;
};

// @public
export function whitespaceFilter(value: Node, index: number, array: Node[]): boolean;

// @public
export const YearFormat: {
    readonly "2-digit": "2-digit";
    readonly numeric: "numeric";
};

// @public
export type YearFormat = typeof YearFormat[keyof typeof YearFormat];

// Warnings were encountered during analysis:
//
// dist/dts/calendar/calendar.d.ts:49:5 - (ae-incompatible-release-tags) The symbol "dataGridCell" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/calendar/calendar.d.ts:50:5 - (ae-incompatible-release-tags) The symbol "dataGridRow" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/calendar/calendar.d.ts:51:5 - (ae-incompatible-release-tags) The symbol "dataGrid" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/data-grid/data-grid-row.template.d.ts:9:5 - (ae-incompatible-release-tags) The symbol "dataGridCell" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/data-grid/data-grid.template.d.ts:9:5 - (ae-incompatible-release-tags) The symbol "dataGridRow" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/design-token/design-token.d.ts:91:5 - (ae-forgotten-export) The symbol "create" needs to be exported by the entry point index.d.ts
// dist/dts/menu-item/menu-item.d.ts:20:5 - (ae-incompatible-release-tags) The symbol "anchoredRegion" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/picker/picker.template.d.ts:9:5 - (ae-incompatible-release-tags) The symbol "anchoredRegion" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/picker/picker.template.d.ts:10:5 - (ae-incompatible-release-tags) The symbol "pickerMenu" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/picker/picker.template.d.ts:11:5 - (ae-incompatible-release-tags) The symbol "pickerMenuOption" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/picker/picker.template.d.ts:12:5 - (ae-incompatible-release-tags) The symbol "pickerList" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/picker/picker.template.d.ts:13:5 - (ae-incompatible-release-tags) The symbol "pickerListItem" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/picker/picker.template.d.ts:14:5 - (ae-incompatible-release-tags) The symbol "progressRing" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta
// dist/dts/tooltip/tooltip.template.d.ts:9:5 - (ae-incompatible-release-tags) The symbol "anchoredRegion" is marked as @public, but its signature references "TemplateElementDependency" which is marked as @beta

// (No @packageDocumentation comment for this package)

```
